function coef_vals = learn_coefficients(dictionary_n, x_im, opts)

    %% Unpackage needed options
    lambda = opts.lambda;
    tol = opts.l1ls_tol;
    nneg = opts.nneg;
    pp = opts.parallel;
    quiet = 1;
    N = opts.minibatch_size;

    %% Initialize Coefficients
    coef_vals = zeros(opts.num_elem, opts.minibatch_size);

    %% Learn each coefficient vector (in parallel)

    if nneg
        if pp
            parfor idx = 1:N
                coef_vals(:, idx) = l1_ls_nneg(dictionary_n, x_im(:,idx), lambda, tol, quiet);
            end
        else
            for idx = 1:N
                coef_vals(:, idx) = l1_ls_nneg(dictionary_n, x_im(:,idx), lambda, tol, quiet);
            end
        end
    else
        if pp
            parfor idx = 1:N
                coef_vals(:, idx) = l1_ls(dictionary_n, x_im(:,idx), lambda, tol, quiet);
            end
        else
            for idx = 1:N
                coef_vals(:, idx) = l1_ls(dictionary_n, x_im(:,idx), lambda, tol, quiet);
            end
        end
    end

end